package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.audio.ISample;
import com.danitheskunk.skunkworks.gfx.Color;
import com.danitheskunk.skunkworks.gfx.IRenderContext;
import com.danitheskunk.skunkworks.nodes.NodeSprite;
import com.danitheskunk.skunkworks.nodes.NodeText;

public class TestNode extends BaseGame {
	private final ISample kick;
	private final NodeSprite sprite;
	private final NodeText text;
	private final NodeText text2;
	float[] axes;

	public TestNode() {
		super(new Vec2i(1920, 1080), "Skunkworks");

		kick = loadSample("demoassets/kick.wav");
		var font = window.loadFontTileset("fonts/ega-8x14.png");
		var font2 = window.loadFontTTF("fonts/m3x6.ttf", 12.7f);
		var str =
			"As Gauntlet of Power enters the battlefield, choose a color.\n" +
				"\n" +
				"Creatures of the chosen color get +1/+1.\n" +
				"\n" +
				"Whenever a basic land is tapped for mana of the chosen color, its controller adds an additional one mana of that color.\n";
		text = new NodeText(font, str);
		text2 = new NodeText(font2, str);
		text.setMaxSize(new Vec2i(300, 100));
		text2.setMaxSize(new Vec2i(200, 100));
		text2.setColor(Color.BLACK);
		text.setColor(Color.BLACK);
		sprite = new NodeSprite();
		sprite.setTexture(loadTexture("demoassets/card.png"));
		sprite.setPos(new Vec2f(100, 100));
		//rootNode.add(sprite);
		rootNode.add(text);
		rootNode.add(text2);
		//doThing();

	}

	public static void main(String[] args) {
		new TestNode().run();
	}

	void doThing() {
		sprite.tweenPos(new Vec2f(800, 400), 120).delay(60).then(() -> {
			System.out.println("yay! got there! now lets go home");
			sprite.tweenPos(new Vec2f(100, 100), 120).then(this::doThing);
			playSample(kick);
		});
	}

	@Override
	protected void render(IRenderContext rc) {
		rc.clear(Color.WHITE);
	}

	@Override
	protected void update(double delta) {
		text.setPos(new Vec2f(
			640 + 640 * gamepad.getAxis(0),
			360 + 360 * gamepad.getAxis(1)
		));
		text2.setPos(new Vec2f(
			440 + 640 * gamepad.getAxis(0),
			360 + 360 * gamepad.getAxis(1)
		));
		if(gamepad.getButtonPressed(0)) {
			playSample(kick);
		}
	}
}

